import JMyron.*;
import controlP5.*;


JMyron m;

ControlP5 controlP5;

int RedValue = 20;
int GreenValue = 150;
int BlueValue = 20;
int RangeValue = 125;
int DensityValue = 100;

int R;
int G;
int B;
int range;

color cor;

 
void setup(){
  size(320,400);
  m = new JMyron();
  m.start(320,240);
  m.findGlobs(1);
 
 controlP5 = new ControlP5(this);

  controlP5.addSlider("RedValue",0,255,RedValue,80,240+25,100,10);
  controlP5.addSlider("GreenValue",0,255,GreenValue,80,240+50,100,10);
  controlP5.addSlider("BlueValue",0,255,BlueValue,80,240+75,100,10);
  controlP5.addSlider("RangeValue",0,255,RangeValue,80,240+100,100,10);
  controlP5.addSlider("DensityValue",0,10000,DensityValue,80,240+125,100,10);
  
  background(0); 
}


void draw(){

  fill(RedValue,GreenValue,BlueValue);
   rect(0, 240, 320, 10);

  m.minDensity(DensityValue); //minimum pixels in the glob required to result in a box
  m.trackColor(RedValue,GreenValue,BlueValue,RangeValue);//R, G, B, and range of similarity
  m.update();


//first draw the camera view onto the screen
 int[] img = m.image(); //get the normal image of the camera
  loadPixels();
  for(int i=0;i<320*240;i++){ //loop through all the pixels
    pixels[i] = img[i]; //draw each pixel to the screen
  }
  updatePixels();
 
  
  
  noFill();
  int[][] a;


  //draw center points of globs
  a = m.globCenters();
  stroke(255,255,0);
  for(int i=0;i<a.length;i++){
    int[] p = a[i];
    point(p[0],p[1]);
  }
 

  //draw bounding boxes of globs
  a = m.globBoxes();
  stroke(0,0,0);
  for(int i=0;i<a.length;i++){
    int[] b = a[i];
 
    rect(b[0], b[1], b[2], b[3]);
  }


  //draw edge pixels of globs (this and the next chunks of code are chokers)
  int list[][][] = m.globPixels();
  stroke(110,110,110);
  
  for(int i=0;i<list.length;i++){
    int[][] pixellist = list[i];
    if(pixellist!=null){
      beginShape(POINTS);
      for(int j=0;j<pixellist.length;j++){    
        vertex( pixellist[j][0]  ,  pixellist[j][1] );
       // print( pixellist[j][0]  +" " +  pixellist[j][1] );
      }
      endShape();
     }
  }

  //draw edge points (same as last, but vector based)
  list = m.globEdgePoints(20);
  stroke(0,128,0);
  for(int i=0;i<list.length;i++){
    int[][] contour = list[i];
    if(contour!=null){
      beginShape();
      for(int j=0;j<contour.length;j++){    
        vertex( contour[j][0]  ,  contour[j][1] );
      }
      endShape();
     }
  }
  


  //draw quads - like bounding box, but a 4-pointed polygon.
/*  a = m.globQuads(50,51);
  stroke(0,0,100);
  for(int i=0;i<a.length;i++){
    int[] b = a[i];
    quad(b[0], b[1],
         b[2], b[3],
         b[4], b[5],
         b[6], b[7]);
  }
*/


}

public void stop(){
  m.stop();
  super.stop();
}

void mousePressed(){
if (mouseY<240){
  m.settings();
   }
 }


